> For clean Markdown of any page, append .md to the page URL. > For a complete documentation index, see https://docs.getunleash.io/api/update-actions/llms.txt. > For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.getunleash.io/_mcp/server. # [BETA] Update an action set. PUT https://app.unleash-instance.example.com/api/admin/projects/{projectId}/actions/{id} Content-Type: application/json **Enterprise feature** **[BETA]** This API is in beta state, which means it may change or be removed in the future. Updates an existing action set identified by its id. Reference: https://docs.getunleash.io/api/update-actions ## Authentication - `Authorization` header (required) — API key needed to access this API - `Authorization` header (bearer token, required) — API key needed to access this API, in Bearer token format ## Request ### Path parameters - `projectId` (string, required) - `id` (string, required) ### Body (application/json) This endpoint expects a createActionsSchema. - `name` (string, required) — The name of the action set - `actorId` (integer, required) — The id of the service account that will execute the action - `actions` (list of createActionSchema, required) — The list of actions to execute in sequential order when the action set is triggered - `match` (CreateActionsSchemaMatch, required) — Defines a matching rule for the signal that will trigger the action set - `description` (string, optional, nullable) — The description of the action set - `enabled` (boolean, optional, default: true) — Whether this action set is enabled or not ## Response ### 200 actionsSchema - `id` (integer, required) — The ID of the action set. - `project` (string, required) — The project that this action set belongs to. - `createdAt` (string, required) — The date and time of when the action set was created. - `createdByUserId` (integer, required) — The ID of the user that created this action set. - `name` (string, required) — The name of the action set - `actorId` (integer, required) — The id of the service account that will execute the action - `actions` (list of actionSchema, required) — The list of actions to execute in sequential order when the action set is triggered. - `match` (ActionsSchemaMatch, required) — Defines a matching rule for the signal that will trigger the action set - `description` (string, optional, nullable) — The description of the action set - `enabled` (boolean, optional, default: true) — Whether this action set is enabled or not ## Errors ### 400 Bad Request Error The request data does not match what we expect. - `id` (string, optional) — The ID of the error instance - `name` (string, optional) — The name of the error kind - `message` (string, optional) — A description of what went wrong. ### 401 Unauthorized Error Authorization information is missing or invalid. Provide a valid API token as the `authorization` header, e.g. `authorization:*.*.my-admin-token`. - `id` (string, optional) — The ID of the error instance - `name` (string, optional) — The name of the error kind - `message` (string, optional) — A description of what went wrong. ### 403 Forbidden Error The provided user credentials are valid, but the user does not have the necessary permissions to perform this operation - `id` (string, optional) — The ID of the error instance - `name` (string, optional) — The name of the error kind - `message` (string, optional) — A description of what went wrong. ### 404 Not Found Error The requested resource was not found. - `id` (string, optional) — The ID of the error instance - `name` (string, optional) — The name of the error kind - `message` (string, optional) — A description of what went wrong. ### 415 Unsupported Media Type Error The operation does not support request payloads of the provided type. Please ensure that you're using one of the listed payload types and that you have specified the right content type in the "content-type" header. - `id` (string, optional) — The ID of the error instance - `name` (string, optional) — The name of the error kind - `message` (string, optional) — A description of what went wrong. ## Types ### createActionSchema Represents a single action - `action` (string, required) — The name of the action to execute - `sortOrder` (integer, required) — The order in which the action should be executed - `executionParams` (map from string to any, optional, default: {}) — A map of parameters to pass to the action ### CreateActionsSchemaMatch Defines a matching rule for the signal that will trigger the action set - `source` (enum, required) — Match the source of the signal - Allowed values: `signal-endpoint` - `sourceId` (double, required) — Match the source id of the signal - `payload` (map from string to any, required) — Match the payload of the signal ### actionSchema Represents a single action response - `id` (integer, required) — The id of the action set - `createdAt` (string, required) — The date and time of when the action was created. - `createdByUserId` (integer, required) — The id of user that created this action set - `action` (string, required) — The name of the action to execute - `sortOrder` (integer, required) — The order in which the action should be executed - `executionParams` (map from string to any, optional, default: {}) — A map of parameters to pass to the action ### ActionsSchemaMatch Defines a matching rule for the signal that will trigger the action set - `source` (enum, required) — Match the source of the signal - Allowed values: `signal-endpoint` - `sourceId` (double, required) — Match the source id of the signal - `payload` (map from string to any, required) — Match the payload of the signal ## Examples **Request** ```json { "name": "Disable new features", "actorId": 12, "actions": [ { "action": "disable-feature", "sortOrder": 1 } ], "match": { "source": "signal-endpoint", "sourceId": 123, "payload": { "type": "error-rate-above-threshold" } } } ``` **Response** ```json { "id": 1, "project": "default", "createdAt": "2023-12-27T13:37:00+01:00", "createdByUserId": 1, "name": "Disable new features", "actorId": 12, "actions": [ { "id": 1, "createdAt": "2023-12-27T13:37:00+01:00", "createdByUserId": 1, "action": "disable-feature", "sortOrder": 1, "executionParams": { "featureName": "my-feature" } } ], "match": { "source": "signal-endpoint", "sourceId": 123, "payload": { "type": "error-rate-above-threshold" } }, "description": "Disables new features when error rate is above threshold", "enabled": true } ``` **SDK Code** ```python import requests url = "https://app.unleash-instance.example.com/api/admin/projects/projectId/actions/id" payload = { "name": "Disable new features", "actorId": 12, "actions": [ { "action": "disable-feature", "sortOrder": 1 } ], "match": { "source": "signal-endpoint", "sourceId": 123, "payload": { "type": "error-rate-above-threshold" } } } headers = { "Authorization": "", "Content-Type": "application/json" } response = requests.put(url, json=payload, headers=headers) print(response.json()) ``` ```javascript const url = 'https://app.unleash-instance.example.com/api/admin/projects/projectId/actions/id'; const options = { method: 'PUT', headers: {Authorization: '', 'Content-Type': 'application/json'}, body: '{"name":"Disable new features","actorId":12,"actions":[{"action":"disable-feature","sortOrder":1}],"match":{"source":"signal-endpoint","sourceId":123,"payload":{"type":"error-rate-above-threshold"}}}' }; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://app.unleash-instance.example.com/api/admin/projects/projectId/actions/id" payload := strings.NewReader("{\n \"name\": \"Disable new features\",\n \"actorId\": 12,\n \"actions\": [\n {\n \"action\": \"disable-feature\",\n \"sortOrder\": 1\n }\n ],\n \"match\": {\n \"source\": \"signal-endpoint\",\n \"sourceId\": 123,\n \"payload\": {\n \"type\": \"error-rate-above-threshold\"\n }\n }\n}") req, _ := http.NewRequest("PUT", url, payload) req.Header.Add("Authorization", "") req.Header.Add("Content-Type", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby require 'uri' require 'net/http' url = URI("https://app.unleash-instance.example.com/api/admin/projects/projectId/actions/id") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Put.new(url) request["Authorization"] = '' request["Content-Type"] = 'application/json' request.body = "{\n \"name\": \"Disable new features\",\n \"actorId\": 12,\n \"actions\": [\n {\n \"action\": \"disable-feature\",\n \"sortOrder\": 1\n }\n ],\n \"match\": {\n \"source\": \"signal-endpoint\",\n \"sourceId\": 123,\n \"payload\": {\n \"type\": \"error-rate-above-threshold\"\n }\n }\n}" response = http.request(request) puts response.read_body ``` ```java import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.put("https://app.unleash-instance.example.com/api/admin/projects/projectId/actions/id") .header("Authorization", "") .header("Content-Type", "application/json") .body("{\n \"name\": \"Disable new features\",\n \"actorId\": 12,\n \"actions\": [\n {\n \"action\": \"disable-feature\",\n \"sortOrder\": 1\n }\n ],\n \"match\": {\n \"source\": \"signal-endpoint\",\n \"sourceId\": 123,\n \"payload\": {\n \"type\": \"error-rate-above-threshold\"\n }\n }\n}") .asString(); ``` ```php request('PUT', 'https://app.unleash-instance.example.com/api/admin/projects/projectId/actions/id', [ 'body' => '{ "name": "Disable new features", "actorId": 12, "actions": [ { "action": "disable-feature", "sortOrder": 1 } ], "match": { "source": "signal-endpoint", "sourceId": 123, "payload": { "type": "error-rate-above-threshold" } } }', 'headers' => [ 'Authorization' => '', 'Content-Type' => 'application/json', ], ]); echo $response->getBody(); ``` ```csharp using RestSharp; var client = new RestClient("https://app.unleash-instance.example.com/api/admin/projects/projectId/actions/id"); var request = new RestRequest(Method.PUT); request.AddHeader("Authorization", ""); request.AddHeader("Content-Type", "application/json"); request.AddParameter("application/json", "{\n \"name\": \"Disable new features\",\n \"actorId\": 12,\n \"actions\": [\n {\n \"action\": \"disable-feature\",\n \"sortOrder\": 1\n }\n ],\n \"match\": {\n \"source\": \"signal-endpoint\",\n \"sourceId\": 123,\n \"payload\": {\n \"type\": \"error-rate-above-threshold\"\n }\n }\n}", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ``` ```swift import Foundation let headers = [ "Authorization": "", "Content-Type": "application/json" ] let parameters = [ "name": "Disable new features", "actorId": 12, "actions": [ [ "action": "disable-feature", "sortOrder": 1 ] ], "match": [ "source": "signal-endpoint", "sourceId": 123, "payload": ["type": "error-rate-above-threshold"] ] ] as [String : Any] let postData = JSONSerialization.data(withJSONObject: parameters, options: []) let request = NSMutableURLRequest(url: NSURL(string: "https://app.unleash-instance.example.com/api/admin/projects/projectId/actions/id")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "PUT" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ```